% kubtssprop is edited by shooting stars propeller team
%-------------------------------------------------------------
clear all
global U Rout Rin R RPM N Po
global X Z Chord Cl Cd Theta Re phi psi
global nu RHO delta alpha constraint constrait_Re omega r dT con
U = 6.8;           %@ (m/s)
N = 70;            %
Rin = 50/1000;      %y (m)
Rout = 1445/1000;   %y[ (m)
RPM = 162;          %RPM (rpm)
Po = 240;           %p[ (W)
constraint = 0.20;  %
%-------萔-------------------------------------------------------
RHO = 1.225;         %Cx  
nu = 1.463*10^(-5);  %SW

%-------option----------------------------------------------------
%-------0off 1on----------------------------------------------
p1 = 0;              %txtŏo
p2 = 1;              %ChordȂǂ̃Ot̏o


%-------zl-------------------------------------------------
k = 1:N;
gam = sin((k/N)*pi)+0.1;                 %zl
gam = gam';

%-------ԃp[^쐬------------------------------------------
t1 = 1/2000;                             %yt߂t_step
t2 = 1/20;                               %ꂽƂt_step
lambda = 40;                             %̑̃p[^
t_length = 100;
t = [0:t_length];
t_step = 1./(1+exp(t/lambda));
t_step = 1-2*t_step;
t_step = (t_step)*(t2-t1)+t1;
t = cumsum(t_step);
for i = 1:t_length+1
    t(i) = t(i)-t_step(i);
end
disp('ԃp[^쐬')
t_minimum = Rout*10/U;                   %]a10{x܂ŌvZ

%-----CP,DP̍Wݒ---------------------------------------------
omega = RPM/60*2*pi;
R = Rout-Rin;
delta = R/N;
psi = omega*t;
psi = -psi;              %v肾
A = (1:N)-1/2;
r = delta*A;                                       
DPb = (0:N)*delta+Rin;
CPx = zeros(1,N);
CPy = r+Rin;
CPz = zeros(1,N);
DPx1 = -U*ones(N+1,1)*t;
DPy1 = DPb'*cos(psi);
DPz1 = DPb'*sin(psi);
DPx2 = -U*ones(N+1,1)*t;
DPy2 = -DPb'*cos(psi);
DPz2 = -DPb'*sin(psi);

%----Biot-Savart̖@-------------------------------------------------
X = zeros(N,N);
Z = zeros(N,N);

    %---zvZ--------------------------------------------------------------
for j = 1:N
    if mod(j,10) == 0
        str = sprintf('zvZ %d',ceil(j/N*100));
        disp(str)
    end
    
    for i = 1:N
            k = 1:t_length;
            a1 = [(DPx1(j,k)-CPx(i))',(DPy1(j,k)-CPy(i))',(DPz1(j,k)-CPz(i))']';           
            b1 = [(DPx1(j,k+1)-CPx(i))',(DPy1(j,k+1)-CPy(i))',(DPz1(j,k+1)-CPz(i))']';
            
            a2 = [(DPx1(j+1,k)-CPx(i))',(DPy1(j+1,k)-CPy(i))',(DPz1(j+1,k)-CPz(i))']';
            b2 = [(DPx1(j+1,k+1)-CPx(i))',(DPy1(j+1,k+1)-CPy(i))',(DPz1(j+1,k+1)-CPz(i))']';
            
            a3 = [(DPx2(j,k)-CPx(i))',(DPy2(j,k)-CPy(i))',(DPz2(j,k)-CPz(i))']';
            b3 = [(DPx2(j,k+1)-CPx(i))',(DPy2(j,k+1)-CPy(i))',(DPz2(j,k+1)-CPz(i))']';
            
            a4 = [(DPx2(j+1,k)-CPx(i))',(DPy2(j+1,k)-CPy(i))',(DPz2(j+1,k)-CPz(i))']';
            b4 = [(DPx2(j+1,k+1)-CPx(i))',(DPy2(j+1,k+1)-CPy(i))',(DPz2(j+1,k+1)-CPz(i))']';
            
            E = -Fbs(a1,b1)+Fbs(a2,b2)-Fbs(a3,b3)+Fbs(a4,b4);
            F = sum(E,2);
            X(i,j) = F(1,1);
            Z(i,j) = F(3,1);            
            
    end
end

%------œK-------------------------------------------------------
options = optimset('Algorithm','sqp'); 
gam=fmincon(@thrust,gam,[],[],[],[],[],[],@nonlcon,options);
disp('z̍œKC')

%------\---------------------------------------------------------
T = thrust(gam);
T = -T
eta = T*U/Po

%----txtŏo--------------------------------------------------------
if p1 == 1                       
F_alpha;
ChordData = [CPy',Chord];
AngleData = [CPy',Theta];
save Chord.txt ChordData -ascii
save Angle.txt AngleData -ascii
end
%----Oto-------------------------------------------------------
if p2 == 1
scrsz = get(0,'ScreenSize');
figure('Position',[scrsz(4)/10 scrsz(4)/5 scrsz(3)/1.5 scrsz(4)/1.5])
subplot(2,3,1);plot(Chord)
ylabel('Chord')
subplot(2,3,2);plot(phi)
ylabel('phi')
subplot(2,3,3);plot(gam)
ylabel('gam')
subplot(2,3,4);plot(Re)
ylabel('Re')
subplot(2,3,5);plot(Cl)
ylabel('Cl')
subplot(2,3,6);plot(Cd)
ylabel('Cd')
end
