%calculate liftingforce  Kutta-Joukowski theorem
function dL = liftingforce(gam)
global U Rout Rin RPM N Po RHO P X Z R Chord Cl Cd Theta Re phi;
global delta omega nu r;
	uv = X*gam;                
	wv = Z*gam;                 
	Ut = omega*(r'+Rin)-wv;       
 	Up = U-uv;                 
	V = sqrt(Ut.^2+Up.^2);      
	dL = RHO.*V.*delta.*gam;   