%calculate thrust
function T = thrust(gam)
global U Rout Rin RPM N Po RHO P X Z R Chord Cl Cd Theta Re phi dT;
global delta nu;
	dL = liftingforce(gam);
	dD = drag(gam);
	dT = dL.*cos(phi)-dD.*sin(phi); 
    T = -(dT(1)+dT(end)+4*sum(dT(2:2:end-1))+2*sum(dT(3:2:end-1)))/3;    % Vv\̌
	T = T*2;